#!/usr/bin/python
# -*- coding: iso-8859-1 -*-
"""
Boost Software License - Version 1.0 - August 17th, 2003

Permission is hereby granted, free of charge, to any person or organization
obtaining a copy of the software and accompanying documentation covered by
this license (the "Software") to use, reproduce, display, distribute,
execute, and transmit the Software, and to prepare derivative works of the
Software, and to permit third-parties to whom the Software is furnished to
do so, all subject to the following:

The copyright notices in the Software and this entire statement, including
the above license grant, this restriction and the following disclaimer,
must be included in all copies of the Software, in whole or in part, and
all derivative works of the Software, unless such copies or derivative
works are solely in the form of machine-executable object code generated by
a source language processor.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
DEALINGS IN THE SOFTWARE.

"""
import field

from globals import *
from players import *
from com import *
import math

counter = 0

class father(player):
    def __init__(self):
        player.__init__(self)
        
        self.com = communication()
        self.listplayer = []
        self.aktRound = 0
        self.team = team[0]

        (self.id,map,numPlayer) = self.com.connect()
        
        #print "Starting game: ID %d MAP %s with %d players" %(self.id,map,numPlayer)

        aktPlayer = enemyplayer()
        aktPlayer.setID(self.id)
        aktPlayer.setTeam(team[0])
        self.listplayer.append(aktPlayer)

        self.map = field.field(map)
        self.map.readField()

        lastOutput = -1
        try:
            while 1:
                
                playerdata = { "round"   : self.aktRound,
                               "players" : self.listplayer,
                               "me"      : self,
                               "map"     : self.map
                             }
            
                self.com.parseMessage(playerdata)

                if playerdata["round"] != self.aktRound:
                    self.aktRound = playerdata["round"]
             
                for aktplayer in self.listplayer:
                    self.calcDistance(aktplayer)    
                    if aktplayer.team == team[0]:
                        self.map.setBlue(aktplayer.pos)
                    else:
                        self.map.setRed(aktplayer.pos)

                self.listplayer = sorted(self.listplayer,key = lambda eplayer: eplayer.distance)

                self.map.setPlayer(self.pos)

                #print self.map

                if self.team == team[0]:
                    self.moveBlue()
                else:
                    self.moveRed()

        except EndGame as e:
            #print "End game exception!!"
            self.com.endGame()

           
    def calcDistance(self,other):
        return math.sqrt(math.pow(self.pos.x - other.pos.x,2) + math.pow(self.pos.y - other.pos.y,2))

    def __str__(self):
        retstr = player.__str__(self) + " " + str(len(self.listplayer)) + " "

        #for aktplayer in self.listplayer:
        #    retstr += "|" + str(aktplayer) + "|"
        return retstr 


    def moveBlue(self):
        global counter
        dir = directions[counter]

        self.com.sendMove(dir,dir)
        #counter += 1
        if counter == 8:
            counter = 0
        #print self.com.receiveData()
     
    def moveRed(self):

        global counter
        dir = directions[counter]

        self.com.sendMove(dir,dir)
        counter += 1
        if counter == 8:
            counter = 0
        #print self.com.receiveData()
        

if __name__ == "__main__":
    test = father()

    #print test
